/* pnmmerge.c - wrapper program for PNM
**
** Copyright (C) 1991 by Jef Poskanzer.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
*/

#include <stdio.h>
#include <string.h>

int
main( argc, argv )
    int argc;
    char* argv[];
    {
    register char* cp;


again:
    if ( ( cp = strrchr( argv[0], '/' ) ) != (char*) 0 )
	++cp;
    else
	cp = argv[0];
    if ( strcmp( cp, "pnmmerge" ) == 0 )
	{
	++argv;
	--argc;
	if(!*argv)	{
		fprintf(stderr, "Usage: pnmmerge pnm_program_name [args ...]\n");
		exit(1);
		}
	goto again;
	}

    /* merge.h is an automatically generated file that generates code to
       match the string 'cp' against the name of every program that is part
       of this merge and, upon finding a match, invoke that program.
    */

#include "merge.h"   

    /* Now we also check for aliases -- backward compatibility names for
       programs whose names are now different.
       */

    TRY( "pnmnoraw", pnmtoplainpnm_main );
    TRY( "gemtopbm", gemtopnm_main );

    (void) fprintf(
	stderr, "pnmmerge: \"%s\" is an unknown PNM program!\n", cp );
    exit( 1 );
    }
