


CJPEG(1)                                                 CJPEG(1)


[1mNAME[0m
       cjpeg - compress an image file to a JPEG file

[1mSYNOPSIS[0m
       [1mcjpeg[0m [ [4moptions[0m ] [ [4mfilename[0m ]


[1mDESCRIPTION[0m
       [1mcjpeg[0m  compresses  the  named  image file, or the standard
       input if no file is named, and produces a  JPEG/JFIF  file
       on  the  standard  output.   The currently supported input
       file formats are: PPM (PBMPLUS color format), PGM (PBMPLUS
       gray-scale  format), BMP, GIF, Targa, and RLE (Utah Raster
       Toolkit format).   (RLE  is  supported  only  if  the  URT
       library is available.)

[1mOPTIONS[0m
       All   switch   names  may  be  abbreviated;  for  example,
       [1m-grayscale[0m may be written  [1m-gray[0m  or  [1m-gr[0m.   Most  of  the
       "basic"  switches  can  be abbreviated to as little as one
       letter.  Upper and lower case are equivalent (thus [1m-GIF[0m is
       the  same  as  [1m-gif[0m).  British spellings are also accepted
       (e.g., [1m-greyscale[0m), though for brevity these are not  men
       tioned below.

       The basic switches are:

       [1m-quality[0m [4mN[0m
              Scale  quantization tables to adjust image quality.
              Quality is 0 (worst) to 100 (best); default is  75.
              (See below for more info.)

       [1m-grayscale[0m
              Create  monochrome  JPEG file from color input.  Be
              sure  to  use  this  switch  when   compressing   a
              grayscale  GIF  file,  because  [1mcjpeg[0m  isn't bright
              enough to notice  whether  a  GIF  file  uses  only
              shades of gray.  By saying [1m-grayscale[0m, you'll get a
              smaller JPEG file that takes less time to  process.

       [1m-optimize[0m
              Perform  optimization  of  entropy encoding parame
              ters.  Without this,  default  encoding  parameters
              are  used.  [1m-optimize[0m usually makes the JPEG file a
              little smaller, but [1mcjpeg[0m runs somewhat slower  and
              needs much more memory.  Image quality and speed of
              decompression are unaffected by [1m-optimize[0m.

       [1m-progressive[0m
              Create progressive JPEG file (see below).

       [1m-targa[0m Input file is Targa format.  Targa files that  con
              tain an "identification" field will not be automat
              ically recognized by [1mcjpeg[0m; for such files you must



                           15 June 1995                         1





CJPEG(1)                                                 CJPEG(1)


              specify  [1m-targa[0m  to  make  [1mcjpeg[0m treat the input as
              Targa format.  For most Targa files, you won't need
              this switch.

       The  [1m-quality[0m  switch  lets  you trade off compressed file
       size against  quality  of  the  reconstructed  image:  the
       higher  the quality setting, the larger the JPEG file, and
       the closer the output image will be to the original input.
       Normally  you  want  to  use  the  lowest  quality setting
       (smallest file) that decompresses into something  visually
       indistinguishable  from the original image.  For this pur
       pose the quality setting should be between 50 and 95;  the
       default of 75 is often about right.  If you see defects at
       [1m-quality[0m 75, then go up 5 or 10 counts at a time until you
       are  happy  with  the  output image.  (The optimal setting
       will vary from one image to another.)

       [1m-quality[0m 100 will generate a  quantization  table  of  all
       1's,  minimizing  loss in the quantization step (but there
       is still information  loss  in  subsampling,  as  well  as
       roundoff  error).   This setting is mainly of interest for
       experimental purposes.  Quality values above about 95  are
       [1mnot[0m  recommended  for normal use; the compressed file size
       goes up dramatically for hardly any gain in  output  image
       quality.

       In  the other direction, quality values below 50 will pro
       duce very small files  of  low  image  quality.   Settings
       around  5 to 10 might be useful in preparing an index of a
       large image library, for example.  Try [1m-quality[0m 2 (or  so)
       for  some  amusing  Cubist effects.  (Note: quality values
       below about 25 generate 2-byte quantization tables,  which
       are considered optional in the JPEG standard.  [1mcjpeg[0m emits
       a warning message when you  give  such  a  quality  value,
       because  some  other JPEG programs may be unable to decode
       the resulting file.  Use [1m-baseline[0m if you need  to  ensure
       compatibility at low quality values.)

       The [1m-progressive[0m switch creates a "progressive JPEG" file.
       In this type of JPEG file, the data is stored in  multiple
       scans  of increasing quality.  If the file is being trans
       mitted over a slow communications link,  the  decoder  can
       use  the  first  scan  to display a low-quality image very
       quickly, and can then improve the display with each subse
       quent  scan.   The  final image is exactly equivalent to a
       standard JPEG file of the same quality  setting,  and  the
       total  file  size  is  about  the  same --- often a little
       smaller.  [1mCaution:[0m progressive  JPEG  is  not  yet  widely
       implemented,  so  many  decoders  will be unable to view a
       progressive JPEG file at all.

       Switches for advanced users:





                           15 June 1995                         2





CJPEG(1)                                                 CJPEG(1)


       [1m-dct[0m [1mint[0m
              Use integer DCT method (default).

       [1m-dct[0m [1mfast[0m
              Use fast integer DCT (less accurate).

       [1m-dct[0m [1mfloat[0m
              Use floating-point DCT method.  The float method is
              very  slightly  more  accurate than the int method,
              but is much slower unless  your  machine  has  very
              fast   floating-point  hardware.   Also  note  that
              results  of  the  floating-point  method  may  vary
              slightly across machines, while the integer methods
              should give the same results everywhere.  The  fast
              integer method is much less accurate than the other
              two.

       [1m-restart[0m [4mN[0m
              Emit a JPEG restart marker every  N  MCU  rows,  or
              every  N  MCU blocks if "B" is attached to the num
              ber.  [1m-restart[0m [1m0[0m (the  default)  means  no  restart
              markers.

       [1m-smooth[0m [4mN[0m
              Smooth  the  input  image  to  eliminate  dithering
              noise.  N, ranging from 1  to  100,  indicates  the
              strength  of  smoothing.   0 (the default) means no
              smoothing.

       [1m-maxmemory[0m [4mN[0m
              Set limit for amount of memory to use in processing
              large  images.   Value is in thousands of bytes, or
              millions of bytes if "M" is attached to the number.
              For  example,  [1m-max[0m  [1m4m[0m  selects 4000000 bytes.  If
              more space is needed, temporary files will be used.

       [1m-outfile[0m [4mname[0m
              Send  output  image to the named file, not to stan
              dard output.

       [1m-verbose[0m
              Enable debug printout.  More [1m-v[0m's give more output.
              Also, version information is printed at startup.

       [1m-debug[0m Same as [1m-verbose[0m.

       The  [1m-restart[0m  option  inserts  extra markers that allow a
       JPEG decoder to resynchronize after a transmission  error.
       Without  restart  markers, any damage to a compressed file
       will usually ruin the image from the point of the error to
       the  end of the image; with restart markers, the damage is
       usually confined to the portion of the  image  up  to  the
       next  restart  marker.   Of  course,  the  restart markers
       occupy extra space.  We recommend [1m-restart[0m  [1m1[0m  for  images



                           15 June 1995                         3





CJPEG(1)                                                 CJPEG(1)


       that  will  be transmitted across unreliable networks such
       as Usenet.

       The [1m-smooth[0m option filters the input  to  eliminate  fine-
       scale  noise.   This  is  often useful when converting GIF
       files to JPEG: a moderate smoothing factor  of  10  to  50
       gets  rid of dithering patterns in the input file, result
       ing in a smaller JPEG file  and  a  better-looking  image.
       Too  large a smoothing factor will visibly blur the image,
       however.

       Switches for wizards:

       [1m-baseline[0m
              Force a baseline JPEG file to be  generated.   This
              clamps  quantization  values  to 8 bits even at low
              quality settings.

       [1m-qtables[0m [4mfile[0m
              Use the quantization tables given in the  specified
              text file.

       [1m-qslots[0m [4mN[,...][0m
              Select  which  quantization  table  to use for each
              color component.

       [1m-sample[0m [4mHxV[,...][0m
              Set JPEG sampling factors for each color component.

       [1m-scans[0m [4mfile[0m
              Use  the  scan  script  given in the specified text
              file.

       The "wizard" switches  are  intended  for  experimentation
       with  JPEG.   If  you don't know what you are doing, [1mdon't[0m
       [1muse[0m [1mthem[0m.  These switches are documented  further  in  the
       file wizard.doc.

[1mEXAMPLES[0m
       This  example compresses the PPM file foo.ppm with a qual
       ity factor of 60 and saves the output as foo.jpg:

              [1mcjpeg[0m [1m-quality[0m [4m60[0m [4mfoo.ppm[0m [1m>[0m [4mfoo.jpg[0m

[1mHINTS[0m
       Color GIF files are not the ideal input for JPEG; JPEG  is
       really   intended   for  compressing  full-color  (24-bit)
       images.  In particular, don't  try  to  convert  cartoons,
       line  drawings, and other images that have only a few dis
       tinct colors.  GIF works great on these,  JPEG  does  not.
       If  you  want to convert a GIF to JPEG, you should experi
       ment with [1mcjpeg[0m's [1m-quality[0m and [1m-smooth[0m options  to  get  a
       satisfactory  conversion.  [1m-smooth[0m [1m10[0m or so is often help
       ful.



                           15 June 1995                         4





CJPEG(1)                                                 CJPEG(1)


       Avoid running an image through a series of  JPEG  compres
       sion/decompression  cycles.  Image quality loss will accu
       mulate; after ten or so cycles the image may be noticeably
       worse  than  it  was  after one cycle.  It's best to use a
       lossless format while manipulating an image, then  convert
       to  JPEG format when you are ready to file the image away.

       The [1m-optimize[0m option to [1mcjpeg[0m is worth using when you  are
       making  a  "final" version for posting or archiving.  It's
       also a win when you are using low quality settings to make
       very small JPEG files; the percentage improvement is often
       a lot more than it  is  on  larger  files.   (At  present,
       [1m-optimize[0m mode is always selected when generating progres
       sive JPEG files.)

[1mENVIRONMENT[0m
       [1mJPEGMEM[0m
              If this environment variable is set, its  value  is
              the  default  memory limit.  The value is specified
              as described for the  [1m-maxmemory[0m  switch.   [1mJPEGMEM[0m
              overrides the default value specified when the pro
              gram was compiled, and itself is overridden  by  an
              explicit [1m-maxmemory[0m.

[1mSEE[0m [1mALSO[0m
       [1mdjpeg[0m(1), [1mjpegtran[0m(1), [1mrdjpgcom[0m(1), [1mwrjpgcom[0m(1)
       [1mppm[0m(5), [1mpgm[0m(5)
       Wallace,  Gregory  K.  "The JPEG Still Picture Compression
       Standard", Communications of the ACM, April 1991 (vol. 34,
       no. 4), pp. 30-44.

[1mAUTHOR[0m
       Independent JPEG Group

[1mBUGS[0m
       Arithmetic coding is not supported for legal reasons.

       Not  all  variants  of BMP and Targa file formats are sup
       ported.

       The [1m-targa[0m switch is not a bug, it's a feature.  (It would
       be  a bug if the Targa format designers had not been clue
       less.)

       Still not as fast as we'd like.












                           15 June 1995                         5


