


     pbmtopk(1)            AMIGA (6 August 1990)            pbmtopk(1)



     NAME
          pbmtopk - convert a portable bitmap into a packed (PK)
          format font

     SYNOPSIS
          pbmtopk pkfile[.pk] tfmfile[.tfm] resolution [-s designsize]
          [-p num param...] [-C codingscheme] [-F family] [-f optfile]
          [-c num] [-W width] [-H height] [-D depth] [-I ital] [-h
          horiz] [-v vert] [-x xoff] [-y yoff] [pbmfile]...

     DESCRIPTION
          Reads portable bitmaps as input, and produces a packed (PK)
          font file and a TFM (TeX font metric) file as output. The
          resolution parameter indicates the resolution of the font,
          in dots per inch. If the filename "-" is used for any of the
          filenames, the standard input stream (or standard output
          where appropriate) will be used.

     OPTIONS
          -s designsize
               Sets the design size of the font, in TeX's points
               (72.27pt to the inch). The default design size is 1.
               The TFM parameters are given as multiples of the design
               size.

          -p num param...
               Sets the first num font parameters for the font. The
               first seven parameters are the slant, interword
               spacing, interword space stretchability, interword
               space shrinkability, x-height, quad width, and post-
               sentence extra space of the font. Math and symbol fonts
               may have more parameters; see The TeXbook for a list of
               these. Reasonable default values are chosen for
               parameters which are not specified.

          -C codingscheme
               Sets the coding scheme comment in the TFM file.

          -F family
               Sets the font family comment in the TFM file.

          -f optfile
               Reads the file optfile, which should contain a lines of
               the form:

                  filename xoff yoff horiz vert width height depth ital

               The pbm files specified by the filename parameters  are
               inserted  consecutively  in the font with the specified
               attributes. If any of the attributes  are  omitted,  or
               replaced  with  "*", a default value will be calculated
               from the size of the bitmap. The settings  of  the  -W,



     Page 1                                           (printed 3/1/94)






     pbmtopk(1)            AMIGA (6 August 1990)            pbmtopk(1)



               -H,  -D, -I, -h, -v, -x, and -y options do not affected
               characters created in this way.  The  character  number
               can  be  changed by including a line starting with "=",
               followed by the new number.  Lines beginning  with  "%"
               or "#" are ignored.

          -c num
               Sets  the  character  number   of   the   next   bitmap
               encountered to num.

          -W width
               Sets the TFM width of the next character to  width  (in
               design size multiples).

          -H height
               Sets the TFM height of the next character to height (in
               design size multiples).

          -D depth
               Sets the TFM depth of the next character to  depth  (in
               design size multiples).

          -I ital
               Sets the italic correction of  the  next  character  to
               ital (in design size multiples).

          -h horiz
               Sets the horizontal escapement of the next character to
               horiz (in pixels).

          -v vert
               Sets the vertical escapement of the next  character  to
               vert (in pixels).

          -x xoff
               Sets the horizontal offset of  the  next  character  to
               xoff (in pixels).

          -y yoff
               Sets the vertical offset of the next character to  yoff
               (in pixels, from the top row).

     SEE ALSO
          pktopbm(1), pbm(5)

     AUTHOR
          Adapted  from  Tom  Rokicki's   pxtopk   by   Angus   Duggan
          <ajcd@dcs.ed.ac.uk>.







     Page 2                                           (printed 3/1/94)



