


     picttoppm(1)        AMIGA (29 November 1991)         picttoppm(1)



     NAME
          picttoppm - convert a Macintosh PICT file into a portable
          pixmap

     SYNOPSIS
          picttoppm [-verbose] [-fullres] [-noheader] [-quickdraw] [-
          fontdirfile] [pictfile]

     DESCRIPTION
          Reads a PICT file (version 1 or 2) and outputs a portable
          pixmap.  Useful as the first step in converting a scanned
          image to something that can be displayed on Unix.

     OPTIONS
          -fontdir file
               Make the list of BDF fonts in ``file'' available for
               use by picttoppm when drawing text.  See below for the
               format of the fontdir file.

          -fullres
               Force any images in the PICT file to be output with at
               least their full resolution.  A PICT file may indicate
               that a contained image is to be scaled down before
               output.  This option forces images to retain their
               sizes and prevent information loss.  Use of this option
               disables all PICT operations except images.

          -noheader
               Do not skip the 512 byte header that is present on all
               PICT files.  This is useful when you have PICT data
               that was not stored in the data fork of a PICT file.

          -quickdraw
               Execute only pure quickdraw operations.  In particular,
               turn off the interpretation of special PostScript
               printer operations.

          -verbose
               Turns on verbose mode which prints a a whole bunch of
               information that only picttoppm hackers really care
               about.

     BUGS
          The PICT file format is a general drawing format.  picttoppm
          does not support all the drawing commands, but it does have
          full support for any image commands and reasonable support
          for line, rectangle, polgon and text drawing.  It is useful
          for converting scanned images and some drawing conversion.

          Memory is used very liberally with at least 6 bytes needed
          for every pixel.  Large bitmap PICT files will likely run
          your computer out of memory.



     Page 1                                           (printed 3/1/94)






     picttoppm(1)        AMIGA (29 November 1991)         picttoppm(1)



     FONT DIR FILE FORMAT
          picttoppm has a built in default font and your local
          installer probably provided adequate extra fonts.  You can
          point picttoppm at more fonts which you specify in a font
          directory file.  Each line in the file is either a comment
          line which must begin with ``#'' or font information.  The
          font information consists of 4 whitespace spearated fields.
          The first is the font number, the second is the font size in
          pixels, the third is the font style and the fourth is the
          name of a BDF file containing the font.  The BDF format is
          defined by the X window system and is not described here.

          The font number indicates the type face.  Here is a list of
          known font numbers and their faces.

          0    Chicago
          1    application font
          2    New York
          3    Geneva
          4    Monaco
          5    Venice
          6    London
          7    Athens
          8    San Franciso
          9    Toronto
          11   Cairo
          12   Los Angeles
          20   Times Roman
          21   Helvetica
          22   Courier
          23   Symbol
          24   Taliesin

          The font style indicates a variation on the font.  Multiple
          variations may apply to a font and the font style is the sum
          of the variation numbers which are:

          1    Boldface
          2    Italic
          4    Underlined
          8    Outlined
          16   Shadow
          32   Condensed
          64   Extended

          Obviously the font defintions are strongly related to the
          Macintosh.  More font numbers and information about fonts
          can be found in Macintosh documentation.

     SEE ALSO
          Inside Macintosh volumes 1 and 5, ppmtopict(1), ppm(5)




     Page 2                                           (printed 3/1/94)






     picttoppm(1)        AMIGA (29 November 1991)         picttoppm(1)



     AUTHOR
          Copyright 1993 George Phillips





















































     Page 3                                           (printed 3/1/94)



