


     ppmtoacad(1)         AMIGA (10 October 1991)         ppmtoacad(1)



     NAME
          ppmtoacad - convert portable pixmap to AutoCAD database or
          slide

     SYNOPSIS
          ppmtoacad [-dxb] [-poly] [-background colour] [-white] [-
                    aspect ratio] [-8] [ppmfile]

     DESCRIPTION
          Reads a portable pixmap as input.  Produces an AutoCAD(Reg.)
          slide  file or binary database import (.dxb) file as output.
          If no ppmfile is specified,  input  is  read  from  standard
          input.

     OPTIONS
          -dxb An  AutoCAD  binary  database  import  (.dxb)  file  is
               written.  This file is read with the DXBIN command and,
               once loaded, becomes part of  the  AutoCAD  geometrical
               database  and  can  be viewed and edited like any other
               object.  Each sequence of identical  pixels  becomes  a
               separate  object  in  the  database; this can result in
               very large AutoCAD drawing files.  However, if you want
               to trace over a bitmap, it lets you zoom and pan around
               the bitmap as you wish.

          -poly
               If the -dxb option is  not  specified,  the  output  of
               ppmtoacad  is an AutoCAD slide file.  Normally each row
               of pixels is represented by an AutoCAD line entity.  If
               -poly  is  selected,  the pixels are rendered as filled
               polygons.  If the slide is viewed  on  a  display  with
               higher  resolution  than  the  source pixmap, this will
               cause the pixels to  expand  instead  of  appearing  as
               discrete  lines  against  the screen background colour.
               Regrettably, this  representation  yields  slide  files
               which  occupy  more  disc  space  and  take  longer  to
               display.

          -background colour
               Most AutoCAD display drivers can be configured  to  use
               any  available  colour  as the screen background.  Some
               users perfer a black screen background,  others  white,
               while splinter groups advocate burnt ocher, tawny puce,
               and shocking grey.   Discarding  pixels  whose  closest
               AutoCAD   colour   representation   is   equal  to  the
               background colour can substantially reduce the size  of
               the  AutoCAD database or slide file needed to represent
               a bitmap.  If no -background colour is  specified,  the
               screen  background  colour is assumed to be black.  Any
               AutoCAD colour number may be specified  as  the  screen
               background;  colour  numbers are assumed to specify the
               hues  defined  in  the  standard  AutoCAD  256   colour



     Page 1                                           (printed 3/1/94)






     ppmtoacad(1)         AMIGA (10 October 1991)         ppmtoacad(1)



               palette.

          -white
               Since  many  AutoCAD  users  choose  a   white   screen
               background,  this  option  is  provided as a short-cut.
               Specifying -white is identical in effect to -background
               7.

          -aspect ratio
               If the source pixmap had non-square pixels,  the  ratio
               of  the pixel width to pixel height should be specified
               as ratio.  The resulting slide or  .dxb  file  will  be
               corrected  so that pixels on the AutoCAD screen will be
               square.  For example, to correct an image  made  for  a
               320x200 VGA/MCGA screen, specify -aspect 0.8333.

          -8   Restricts the colours in the output file to the  8  RGB
               shades.

          All flags  can  be  abbreviated  to  their  shortest  unique
          prefix.

     BUGS
          AutoCAD has a fixed  palette  of  256  colours,  distributed
          along  the  hue,  lightness,  and  saturation axes.  Pixmaps
          which contain many nearly-identical colours, or colours  not
          closely  approximated  by  AutoCAD's  palette, may be poorly
          rendered.

          ppmtoacad works best if the  system  displaying  its  output
          supports the full 256 colour AutoCAD palette.  Monochrome, 8
          colour, and 16 colour configurations will produce less  than
          optimal results.

          When creating a .dxb file or a slide  file  with  the  -poly
          option, ppmtoacad finds both vertical and horizontal runs of
          identical pixels  and  consolidates  them  into  rectangular
          regions  to  reduce  the  size  of the output file.  This is
          effective for images with large areas of constant colour but
          it's no substitute for true raster to vector conversion.  In
          particular, thin diagonal lines are not optimised at all  by
          this process.

          Output files can be huge.

     SEE ALSO
          AutoCAD Reference Manual:   Slide  File  Format  and  Binary
          Drawing Interchange (DXB) Files, ppm(5)

     AUTHOR
               John Walker
               Autodesk SA



     Page 2                                           (printed 3/1/94)






     ppmtoacad(1)         AMIGA (10 October 1991)         ppmtoacad(1)



               Avenue des Champs-Montants 14b
               CH-2074 MARIN
               Suisse/Schweiz/Svizzera/Svizra/Switzerland
               Usenet:  kelvin@Autodesk.com
               Fax:     038/33 88 15
               Voice:   038/33 76 33

          Permission  to  use,  copy,  modify,  and  distribute   this
          software  and  its documentation for any purpose and without
          fee  is  hereby   granted,   without   any   conditions   or
          restrictions.   This  software is provided ``as is'' without
          express or implied warranty.

          AutoCAD and Autodesk are registered trademarks of  Autodesk,
          Inc.








































     Page 3                                           (printed 3/1/94)



