


     ppmtoxpm(1)          AMIGA (Tue Apr 9 1991)           ppmtoxpm(1)



     NAME
          ppmtoxpm - convert a portable pixmap into an X11 pixmap

     SYNOPSIS
          ppmtoxpm [-name <xpmname>] [-rgb <rgb-textfile>] [<ppmfile>]

     DESCRIPTION
          Reads a portable pixmap as input.  Produces X11 pixmap
          (version 3) as output which can be loaded directly by the
          XPM library.

          The -name option allows one to specify the prefix string
          which is printed in the resulting XPM output.  If not
          specified, will default to the filename (without extension)
          of the <ppmfile> argument.  If -name is not specified and
          <ppmfile> is not specified (i.e. piped input), the prefix
          string will default to the string "noname".

          The -rgb option allows one to specify an X11 rgb text file
          for the lookup of color name mnemonics.  This rgb text file
          is typically the /usr/lib/X11/rgb.txt of the MIT X11
          distribution, but any file using the same format may be
          used.  When specified and a RGB value from the ppm input
          matches a RGB value from the <rgb-textfile>, then the
          corresponding color name mnemonic is printed in the XPM's
          colormap.  If -rgb is not specified, or if the RGB values
          don't match, then the color will be printed with the #RGB,
          #RRGGBB, #RRRGGGBBB, or #RRRRGGGGBBBB hexadecimal format.

          All flags can be abbreviated to their shortest unique
          prefix.

          For example, to convert the file "dot" (found in
          /usr/include/X11/bitmaps), from xbm to xpm one could specify

               xbmtopbm dot | ppmtoxpm -name dot

          or, with a rgb text file (in the local directory)

               xbmtopbm dot | ppmtoxpm -name dot -rgb rgb.txt

     BUGS
          An option to match the closest (rather than exact) color
          name mnemonic from the rgb text would be a desirable
          enhancement.

          Truncation of the least significant bits of a RGB value may
          result in nonexact matches when performing color name
          mnemonic lookups.

     SEE ALSO
          ppm(5)



     Page 1                                           (printed 3/1/94)






     ppmtoxpm(1)          AMIGA (Tue Apr 9 1991)           ppmtoxpm(1)



          XPM Manual by Arnaud Le Hors lehors@mirsa.inria.fr

     AUTHOR
          Copyright (C) 1990 by Mark W. Snitily.

          Permission to use, copy, modify, and distribute this
          software and its documentation for any purpose and without
          fee is hereby granted, provided that the above copyright
          notice appear in all copies and that both that copyright
          notice and this permission notice appear in supporting
          documentation.  This software is provided "as is" without
          express or implied warranty.

          This tool was developed for Schlumberger Technologies, ATE
          Division, and with their permission is being made available
          to the public with the above copyright notice and permission
          notice.

          Upgraded to XPM2 by
             Paul Breslaw, Mecasoft SA, Zurich, Switzerland
          (paul@mecazh.uu.ch)
             Thu Nov  8 16:01:17 1990

          Upgraded to XPM version 3 by
             Arnaud Le Hors (lehors@mirsa.inria.fr)
             Tue Apr 9 1991





























     Page 2                                           (printed 3/1/94)



